﻿package 
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.Mouse;
	import flash.filters.BlurFilter;
	import flash.filters.GlowFilter;
	import flash.events.KeyboardEvent;

	public class Fibonacci extends Sprite
	{
		private var centerX:Number;
		private var centerY:Number;
		private var stack:Array = new Array();
		private var i:Number;
		private var blurFilter:BlurFilter;
		private var glowFilter:GlowFilter;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, eraseHandler);
		}
		
		private function eraseHandler(e:KeyboardEvent):void{
			//removeChildAt(0);
			while(numChildren > 0){
				removeChildAt(0);
			}
		}
		private function clickHandler(e:MouseEvent):void
		{
			centerX = e.stageX;
			centerY = e.stageY;
			i = 0;
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			if(i<120){
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(Math.floor(Math.random()*0x66666F));
				stack[i].graphics.lineStyle(0+i/7,0x000000);
				stack[i].graphics.drawCircle(0,i,5+i/5);
				stack[i].rotation = 200*i;
				stack[i].x = centerX;
				stack[i].y = centerY;
				glowFilter = new GlowFilter();
				blurFilter = new BlurFilter();
				blurFilter.blurX = 1.5+i/7;
				blurFilter.blurY = 1.5+i/7;
				glowFilter.blurX = 1.5+i/8;
				glowFilter.blurX = 1.5+i/8;
				glowFilter.quality = 100;
				glowFilter.alpha   = .8;
				glowFilter.strength = 5;
				glowFilter.inner = false;
				glowFilter.color = 0x000000;
				blurFilter.quality = 100;
				stack[i].filters = [blurFilter,glowFilter];
				addChildAt(stack[i],0);
				i++;
			}else{
				removeEventListener(Event.ENTER_FRAME,enterHandler);
			}
		}
	}
}